/**
 * Une classe pour les exercices 1,2 et 3 de la feuille 4.
 */
public class Liste {

    .....

    // Constructeurs

    /**
     * Construit une liste vide.
     */
        public Liste() {...}

    /**
     * Construit une liste  un lment, l'objet x.
     */
    public Liste(Object x) {...}

    /**
     * Construit une liste dont le premier lment est l'objet x
     * et dont la suite est la liste l.
     */
    public Liste(Object x, Liste l) {...}

    // Primitives

    /**
     * Retourne le premier lment de la liste.
     */
    public Object premier() {...}

    /**
     * Retourne le reste de la liste, c'est  dire la liste initiale
     * sans son premier lment.
     */
    public Liste reste() {...}

    /**
     * Ajoute l'objet x en tte de la liste.
     */
    public void ajouter(Object x) {...}

    /**
     * Supprime l'lment en tte de la liste.
     * Prcondition : la liste n'est pas vide.
     */
    public void supprimer() {...}

    /**
     * Teste si la liste est vide.
     */
    public boolean vide() {...}

    // NON-PRIMITIVES  CRIRE  l'AIDE DES PRIMITIVES

    /**
     * Retourne la longueur de la liste.
     */
    public int longueurIteratif() {
        < COMPLTER>
    }

    /**
     * Retourne la longueur de la liste.
     */
    public int longueurRecursif() {
        < COMPLTER>
    }

    /**
     * Retourne le i-ime lment de la liste. Si i > n o n est le
     * nombre d'lments de la liste, retourne le dernier lment de
     * la liste.
     * Prcondition : i > 0.et la liste n'est pas vide.
     */
    public Object elementIteratif(int i) {
        < COMPLTER>
    }

    /**
     * Retourne le i-ime lment de la liste. Si i > n o n est le
     * nombre d'lments de la liste, retourne le dernier lment de
     * la liste.
     * Prcondition : i > 0.et la liste n'est pas vide.
     */
    public Object elementRecursif(int i) {
        < COMPLTER>
    }

    /**
     * Retourne la position de la premire occurence de l'objet x
     * dans la liste (le premier lment de la liste tant  la
     * position 1). Si l'objet x n'est pas prsent dans la liste,
     * retourne 0.
     */
    public int positionIteratif(Object x) {
        < COMPLTER>
    }

    /**
     * Retourne la position de la premire occurence de l'objet x
     * dans la liste (le premier lment de la liste tant  la
     * position 1). Si l'objet x n'est pas prsent dans la liste,
     * retourne 0.
     */
    public int positionRecursif(Object x) {
        < COMPLTER>
    }

    /**
     * Ajoute l'objet x aprs le i-me lment de la liste.
     * Si i = 0, ajoute l'objet x en tte de la liste.
     * Si i > n o n est le nombre d'lments de la liste, ajoute
     * l'objet x  la fin de la liste.
     */
    public void ajouterIteratif(Object x, int i) {
        < COMPLTER>
    }

    /**
     * Ajoute l'objet x aprs le i-me lment de la liste.
     * Si i = 0, ajoute l'objet x en tte de la liste.
     * Si i > n o n est le nombre d'lments de la liste, ajoute
     * l'objet x  la fin de la liste.
     */
    public void ajouterRecursif(Object x, int i) {
        < COMPLTER>
    }

    /**
     * Supprime le i-ime lment de la liste.
     * Si i > n o n est le nombre d'lments de la liste, ne fait rien.
     * Complexit : O(n) o n est le nombre d'lments de la liste.
     */
    public void supprimerIteratif(int i) {
        < COMPLTER>
    }

    /**
     * Supprime le i-ime lment de la liste.
     * Si i > n o n est le nombre d'lments de la liste, ne fait rien.
     * Complexit : O(n) o n est le nombre d'lments de la liste.
     */
    public void supprimerRecursif(int i) {
        < COMPLTER>
    }
}

/**
 * Une classe pour l'exercice 4 de la feuille 4.
 */
public class Ensemble {

    // ATTRIBUTS

    private Liste l; // la liste ordonne de Monome

    // CONSTRUCTEURS

    /**
     * Construit un ensemble vide.
     */
    public Ensemble() {
        l = new Liste();
    }

    /**
     * Construit un singleton contenant i.
     */
    public Ensemble(int i) {
        l = new Liste(new Integer(i));
    }

    /**
     * Construit un ensemble dont le plus petit lment est i
     * et les autres lments sont ceux de l'ensemble e.
     * Prcondition : pour x dans e, i < e.
     */
    private Ensemble(int i, Ensemble e) {
        l = new Liste(new Integer(i),e.l);
    }

    /**
     * Construit un ensemble  partir de la liste l.
     * Prcondition : la liste l est une liste strictement croissante
     * d'entiers.
     */
    private Ensemble(Liste l) {
        this.l = l;
    }

    // PRIMITIVES

    /**
     * Retourne le plus petit entier de l'ensemble.
     * Prcondition : l'ensemble n'est pas vide.
     */
    private int premier() {
        return ((Integer) l.premier()).intValue();
    }

    /**
     * Retourne l'ensmble priv de son plus petit lment.
     * Prcondition : l'ensemble n'est pas vide.
     */
    private Ensemble reste() {
        return new Ensemble(l.reste());
    }

    // PRIMITIVES (Suite)

    /**
     * Teste si l'ensemble est vide.
     */
    public boolean vide() {
        return l.vide();
    }

    // NON-PRIMITIVES  CRIRE  l'AIDE DES PRIMITIVES

    /**
     * Retourne le cardinal de l'ensemble.
     */
    public int cardinal() {
        < COMPLTER>
    }

    /**
     * Teste si l'ensemble contient l'entier i.
     */
    public boolean contient(int i) {
        < COMPLTER>
    }

    /**
     * Retourne l'union de l'ensemble avec l'ensemble e.
     */
    public Ensemble union(Ensemble e) {
        < COMPLTER>
    }

    /**
     * Retourne l'intersection de l'ensemble avec l'ensemble e.
     */
    public Ensemble inter(Ensemble e) {
        < COMPLTER>
    }

    /**
     * Retourne la diffrence symtrique de l'ensemble avec l'ensemble e.
     */
    public Ensemble difference(Ensemble e) {
        < COMPLTER>
    }

    /**
     * Teste si l'ensemble est inclus dans l'ensemble e.
     */
    public boolean estInclusDans(Ensemble e) {
        < COMPLTER>
    }
}

/**
 * Une classe pour l'exercice 5 de la feuille 4.
 */
public class Polynome {

    // CLASSE INTERNE

    /**
     * Une classe pour reprsenter des monmes. On dit qu'un monme a.X^n
     * est plus "grand" qu'un monme b.X^m si n > m.
     */
    private class Monome {

        < COMPLTER>

        /**
         * Construit le monme de coefficient coef et d'exposant expo.
         * Prcondition : expo >= 0.
         */
        public Monome(int coef, int expo) {
            < COMPLTER>
        }

        /**
         * Teste si le monme est nul.
         */
        public boolean nul() {
            < COMPLTER>
        }

        /**
         * Retourne le monme somme du monme et du monme m.
         * Prcondition : this.expo = m.expo.
         */
        public Monome plus(Monome m) {
            < COMPLTER>
        }

        /**
         * Retourne le monme produit du monme et du monme m.
         */
        public Monome fois(Monome m) {
            < COMPLTER>
        }

        /**
         * Teste si this.expo < m.expo.
         */
        public boolean inferieur(Monome m) {
            < COMPLTER>
        }

        /**
         * Evalue le monme en i, autrement dit calcule la
         * valeur de c * (e^i) o c et e sont respectivement
         * le coefficient et l'exposant du monme.
         */
        public int evaluer(int i) {
            < COMPLTER>
        }

        /**
         * Teste si this = m.
         */
        public boolean egal(Monome m) {
            < COMPLTER>
        }
    }

    // ATTRIBUTS

    private Liste l; // la liste strictement dcroissante (sur
                     // les exposants) des monmes
    // CONSTRUCTEURS
    /**
     * Construit le polynme nul.
     */
    public Polynome() {
        < COMPLTER>
    }

    /**
     * Construit le polynme rduit au monme a.X^n avec
     * a = coef et n = expo.
     * Prcondition : expo >= 0.
     */
    public Polynome(int coef, int expo) {
        < COMPLTER>
    }

    /**
     * Construit un polynme dont le plus grand monme est m
     * et les autres monme sont ceux du polynme p.
     * Prcondition : pour tout monme c.X^k de p, k < n
     * o n est l'exposant de m.
     */
    private Polynome(Monome m, Polynome p) {
        < COMPLTER>
    }

    /**
     * Construit un polynme  partir de la liste l.
     * Prcondition : la liste l est une liste strictement dcroissante
     * de monmes.
     */
    private Polynome(Liste l) {
        < COMPLTER>
    }

    /**
     * Construit le polynme rduit au monme m.
     * Prcondition : m n'est pas nul.
     */
    private Polynome(Monome m) {
        < COMPLTER>
    }

    // PRIMITIVES

    /**
     * Retourne le plus grand monme du polynme.
     */
    private Monome premier() {
        < COMPLTER>
    }

    /**
     * Retourne le polynme priv de son plus grand monme.
     */
    private Polynome reste() {
        < COMPLTER>
    }

    /**
     * Teste si le polynme est nul.
     */
    public boolean nul() {
        < COMPLTER>
    }

    // NON-PRIMITIVES  CRIRE  l'AIDE DES PRIMITIVES

    /**
     * Retourne la somme du polynme avec le polynme p.
     */
    public Polynome plus(Polynome p) {
        < COMPLTER>
    }

    /**
     * Retourne la somme du polynme avec l'entier i.
     */
    public Polynome plus(int i) {
        < COMPLTER>
    }

    /**
     * Retourne la diffrence entre le polynme et le polynme p.
     */
    public Polynome moins(Polynome p) {
        < COMPLTER>
    }

    /**
     * Retourne la diffrence entre le polynme et l'entier i.
     */
    public Polynome moins(int i) {
        < COMPLTER>
    }

    /**
     * Retourne le produit du polynme par le monme m.
     */
    private Polynome fois(Monome m) {
        < COMPLTER>
    }

    /**
     * Retourne le produit du polynme par le polynme p.
     */
    public Polynome fois(Polynome p) {
        < COMPLTER>
    }

    /**
     * Retourne le produit du polynme par l'entier i.
     */
    public Polynome fois(int i) {
        < COMPLTER>
    }

    /**
     * Teste si le polynme est gal au polynme p.
     */
    public boolean egal(Polynome p) {
        < COMPLTER>
    }

    /**
     * Retourne la valeur du polynme pour X = i.
     */
    public int evaluer(int i) {
        < COMPLTER>
    }
}

/**
 * Une classe pour l'exercice 6 de la feuille 4.
 */
public class Intervalle {

    // CLASSE INTERNE

    /**
     * Une classe pour les intervalles simples. Un intervalle simple
     * [x, y] est donn par ses bornes x et y, avec x <= y.
     * On dit que [x, y] est infrieur  [a, b] si y < a.
     * On dit que [x, y] et [a, b] se suivent si a = y + 1.
     */
    private class IS {

        /**
         * Construit l'intervalle simple [x, y].
         * Prcondition : x <= y.
         */
        public IS(int x, int y) {
            < COMPLTER>
        }

        /**
         * Teste si l'intervalle simple est "infrieur"  is et
         * si les deux intervalles simples ne se suivent pas.
         */
        public boolean inferieurU(IS is) {
            < COMPLTER>
        }

        /**
         * Teste si l'intervalle simple est "infrieur"  is.
         */
        public boolean inferieur(IS is) {
            < COMPLTER>
        }

        /**
         * Retourne l'union de l'intervalle simple et de is.
         * Prcondition : inferieurU(is) est faux.
         */
        public IS union(IS is) {
            < COMPLTER>
        }

        /**
         * Retourne l'intersection de l'intervalle simple et de is.
         * Prcondition : inferieur(is) est faux.
         */
        public IS inter(IS is) {
            < COMPLTER>
        }

        /**
         * Retourne le nombre d'entiers contenus dans l'intervalle
         * simple.
         */
        public int cardinal() {
            < COMPLTER>
        }

        /**
         * Teste si l'entier i est contenu dans l'intervalle simple.
         */
        public boolean contient(int i) {
            < COMPLTER>
        }

        /**
         * Teste si l'intervalle simple est inclus dans is.
         */
        public boolean estInclusDans(IS is) {
            < COMPLTER>
        }
    }
    
    // ATTRIBUTS

    private Liste l; // la liste strictement croissante des
                     // intervalles simples
    // CONSTRUCTEURS

    /**
     * Construit un intervalle vide.
     */
    public Intervalle() {
        < COMPLTER>
    }

    /**
     * Construit un intervalle rduit  l'intervalle simple [x, y].
     */
    public Intervalle(int x, int y) {
        < COMPLTER>
    }

    /**
     * onstruit un intervalle  partir de la liste l.
     * Prcondition : la liste l est une la liste strictement
     * croissante d'intervalles simples.
     */
    private Intervalle(Liste l) {
        < COMPLTER>
    }

    /**
     * Construit un intervalle rduit  l'intervalle simple is.
     */
    private Intervalle(IS is) {
        < COMPLTER>
    }

    /**
     * Construit un intervallle dont le plus petit intervalle simple
     * est is et dont les autres intervalles simples sont dans i.
     * Prcondition : is est infrieur  tous les intervalles simples
     * de i.
     */
    private Intervalle(IS is, Intervalle i) {
        < COMPLTER>
    }

    // PRIMITIVES

    /**
     * Retourne le plus petit intervalle simple de l'intervalle.
     * Prcondition : l'intervalle n'est pas vide.
     */
    private IS premier() {
        < COMPLTER>
    }

    /**
     * Retourne l'intervalle prive de son plus  petit intervalle simple.
     * Prcondition : l'intervalle n'est pas vide.
     */
    private Intervalle reste() {
        < COMPLTER>
    }

    /**
     * Teste si l'intervalle est vide.
     */
    public boolean vide() {
        < COMPLTER>
    }

    // NON-PRIMITIVES  CRIRE  l'AIDE DES PRIMITIVES

    /**
     * Test si l'intervalle contient l'entier x.
     */
    public boolean contient(int x) {
        < COMPLTER>
    }

    /**
     * Retourne le cardinal de l'intervalle.
     */
    public int cardinal() {
        < COMPLTER>
    }

    /**
     * Retourne l'union de l'intervalle avec l'intervalle i.
     */
    public Intervalle union(Intervalle i) {
        < COMPLTER>
    }

    /**
     * Retourne l'intersection de l'ensemble avec l'ensemble e.
     */
    public Intervalle inter(Intervalle i) {
        < COMPLTER>
    }

    /**
     * Teste si l'intervalle est inclus dans l'intervalle i.
     */
    public boolean estInclusDans(Intervalle i) {
        < COMPLTER>
    }
}
