package asd.td4;

import asd.base.Liste;

/**
 * Une classe pour l'exercice 6 de la feuille 4.
 */
public class Intervalle {

    // CLASSE INTERNE

    /**
     * Une classe pour les intervalles simples. Un intervalle simple
     * [x, y] est donn par ses bornes x et y, avec x <= y.
     * On dit que [x, y] est infrieur  [a, b] si y < a.
     * On dit que [x, y] et [a, b] se suivent si a = y + 1.
     */
    private class IS {

        /**
         * Construit l'intervalle simple [x, y].
         * Prcondition : x <= y.
         */
        public IS(int x, int y) {
        }

        /**
         * Teste si l'intervalle simple est "infrieur"  is et
         * si les deux intervalles simples ne se suivent pas.
         */
        public boolean inferieurU(IS is) {
            return false;
        }

        /**
         * Teste si l'intervalle simple est "infrieur"  is.
         */
        public boolean inferieur(IS is) {
            return false;
        }

        /**
         * Retourne l'union de l'intervalle simple et de is.
         * Prcondition : inferieurU(is) est faux.
         */
        public IS union(IS is) {
            return null;
        }

        /**
         * Retourne l'intersection de l'intervalle simple et de is.
         * Prcondition : inferieur(is) est faux.
         */
        public IS inter(IS is) {
            return null;
        }

        /**
         * Retourne le nombre d'entiers contenus dans l'intervalle
         * simple.
         */
        public int cardinal() {
            return 0;
        }

        /**
         * Teste si l'entier i est contenu dans l'intervalle simple.
         */
        public boolean contient(int i) {
            return false;
        }

        /**
         * Teste si l'intervalle simple est inclus dans is.
         */
        public boolean estInclusDans(IS is) {
            return false;
        }

        /**
         * Retourne une chane de caractres correspondant  la
         * reprsentation externe de l'intervalle simple.
         */
        public String toString() {
            return "[" + x + ", " + y + "]";
        }
    }
    
    // ATTRIBUTS

    private Liste l; // la liste strictement croissante des
                           // intervalles simples
    // CONSTRUCTEURS

    /**
     * Construit un intervalle vide.
     */
    public Intervalle() {
    }

    /**
     * Construit un intervalle rduit  l'intervalle simple [x, y].
     */
    public Intervalle(int x, int y) {
    }

    /**
     * onstruit un intervalle  partir de la liste l.
     * Prcondition : la liste l est une la liste strictement
     * croissante d'intervalles simples.
     */
    private Intervalle(Liste l) {
    }

    /**
     * Construit un intervalle rduit  l'intervalle simple is.
     */
    private Intervalle(IS is) {
    }

    /**
     * Construit un intervallle dont le plus petit intervalle simple
     * est is et dont les autres intervalles simples sont dans i.
     * Prcondition : is est infrieur  tous les intervalles simples
     * de i.
     */
    private Intervalle(IS is, Intervalle i) {
    }

    /**
     * Retourne une chane de caractres reprsentant l'intervalle.
     * Complexit : O(n) o n est le nombre d'intervalless simples de this.
     */
    public String toString() {
        if ( vide() ) {
            return "[]";
        }
        Liste ll = l;
        String s = ll.premier().toString();
        ll = ll.reste();
        while ( ! ll.vide() ) {
            s = s + " U " + ll.premier().toString();
            ll = ll.reste();
        }
        return s;
    }

    // PRIMITIVES

    /**
     * Retourne le plus petit intervalle simple de l'intervalle.
     * Prcondition : l'intervalle n'est pas vide.
     */
    private IS premier() {
        return null;
    }

    /**
     * Retourne l'intervalle prive de son plus  petit intervalle simple.
     * Prcondition : l'intervalle n'est pas vide.
     */
    private Intervalle reste() {
        return null;
    }

    /**
     * Teste si l'intervalle est vide.
     */
    public boolean vide() {
        return false;
    }

    // NON-PRIMITIVES  CRIRE  l'AIDE DES PRIMITIVES

    /**
     * Test si l'intervalle contient l'entier x.
     */
    public boolean contient(int x) {
        return false;
    }

    /**
     * Retourne le cardinal de l'intervalle.
     */
    public int cardinal() {
        return 0;
    }

    /**
     * Retourne l'union de l'intervalle avec l'intervalle i.
     */
    public Intervalle union(Intervalle i) {
        return this;
    }

    /**
     * Retourne l'intersection de l'ensemble avec l'ensemble e.
     */
    public Intervalle inter(Intervalle i) {
        return this;
    }

    /**
     * Teste si l'intervalle est inclus dans l'intervalle i.
     */
    public boolean estInclusDans(Intervalle i) {
        return false;
    }
}
